from _add_use_case_scripts.requestPost  import postLayersToSwagger, postTableToSwagger
def add_table(use_case: str, table_name: str):
    '''
    take the columns and add the mappings at the server
    replace all "/"'s in the internal representation with a "_"
    '''

    columns = [
        "changeType",
        "changedValue",
        "previousValue",
        "newValue",
    ]
    
    columns = { c : c for c in columns }
    columns["UniqueID"] = "videoId+changeId"
    columns["changeType"] = "enum(changeType)"
    columns["changedValue"] = "enum(changedValue)"

    table = {
        "name": table_name,
        "mappings": columns
    }

    postTableToSwagger(use_case,table)

def add_layers(use_case:str, table_name: str):
    layers = [
        {
            "use_case": use_case,
            "table": table_name,
            "name": "Changetype_Layer",
            "properties": [
                "changeType",
            ],
            "cluster_properties": [
                "changeType",
            ]
        },
        {
            "use_case": use_case,
            "table": table_name,
            "name": "Changedvalue_Layer",
            "properties": [
                "changedValue",
                "previousValue",
                "newValue"
            ],
            "cluster_properties": [
                "changedValue"
            ]
        }
    ]

    postLayersToSwagger(use_case,layers)    


def main(use_case: str):
    print("user")
    table_name = "change"
    add_table(use_case,table_name)
    add_layers(use_case,table_name)